/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef REQUESTHANDLERMANAGER_H
#define REQUESTHANDLERMANAGER_H

#include "assistant/session.h"
#include "requesthandler.h"

class RequestHandlerManager {
public:
    RequestHandlerManager();
    assistant::ErrorCode handleRequest(
        GDBusConnection *connection, const std::string &message,
        assistant::session::DialogueSession &session);

private:
    void init();
    void handleRequestWithInvalidParam(
        GDBusConnection *connection,
        assistant::session::DialogueSession &session);

private:
    std::shared_ptr<RequestHandler> chatRequestHandler_{nullptr};
};

#endif  // REQUESTHANDLERMANAGER_H
